/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2013, Laboratory of Plasmas Physic - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#ifndef APBUARTPLUGIN_H
#define APBUARTPLUGIN_H
#include <QMenuBar>
#include <QMenu>
#include <QAction>
#include <QLayout>

#include <socexplorerplugin.h>
#include <apbuartpluginui.h>
#include <QTimer>

#define  APB_UART_DATA_REG          0x0
#define  APB_UART_STATUS_REG        0x4
#define  APB_UART_CONTROL_REG       0x8
#define  APB_UART_SCALE_REG         0xC
#define  APB_UART_FIFO_DEBUG_REG    0x10


class ApbUartPlugin : public socexplorerplugin
{
    Q_OBJECT
public:
    explicit ApbUartPlugin(QWidget *parent = 0);
    ~ApbUartPlugin();
    int VID(){return driver_VID;}
    int PID(){return driver_PID;}
    
public slots:
    unsigned int Write(unsigned int *Value,unsigned int count, unsigned int address=0);
    unsigned int Read(unsigned int *Value,unsigned int count, unsigned int address=0);
    void closeMe();
    void postInstantiationTrigger();
    void loopbackChangeState( int state );
    void uartReadout();
    void activateScan(bool flag);
    void activate(bool flag);
signals:
    void apbUartTextReceived(QString text);
private:
    ApbUartPluginUi* UI;
    bool useLoopBack;
    QTimer loopBackTimer;
    int enableLoopback();
    int disableLoopback();
};

#endif // APBUARTPLUGIN_H

